"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var modal_utils_1 = require("../../utils/modal.utils");
var ContainerComponent = (function () {
    /**
     *
     */
    function ContainerComponent(componentFactoryResolver) {
        var _this = this;
        this.componentFactoryResolver = componentFactoryResolver;
        this.modalInstances = [];
        modal_utils_1.ModalUtils.configuration.subscribe(function (config) {
            if (config != null) {
                var newInstance = {};
                Object.assign(newInstance, config);
                _this.modalInstances.push(newInstance);
                var bodyTag = document.getElementsByTagName("body")[0];
                if (!bodyTag.classList.contains('modal-open')) {
                    bodyTag.classList.add("modal-open");
                }
            }
        });
    }
    /**
     * EventHandler if a Modal requests a close action
     */
    ContainerComponent.prototype.onClose = function (modal) {
        for (var i = 0; i < this.modalInstances.length; i++) {
            if (this.modalInstances[i] == modal) {
                this.modalInstances.splice(i, 1);
            }
        }
        if (this.modalInstances.length == 0) {
            var bodyTag = document.getElementsByTagName("body")[0];
            bodyTag.classList.remove("modal-open");
        }
    };
    return ContainerComponent;
}());
ContainerComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'modal-container',
                template: "\n      <modal *ngFor=\"let modal of modalInstances\" [config]=\"modal\" (closed)=\"onClose(modal)\"></modal>\n    ",
            },] },
];
/** @nocollapse */
ContainerComponent.ctorParameters = function () { return [
    { type: core_1.ComponentFactoryResolver, },
]; };
exports.ContainerComponent = ContainerComponent;
//# sourceMappingURL=container.component.js.map