import { OnInit, EventEmitter, ViewContainerRef, ComponentFactoryResolver } from '@angular/core';
export declare class ModalComponent implements OnInit {
    private componentFactoryResolver;
    isVisible: boolean;
    protected promptValue: string;
    private componentRef;
    protected target: any | ViewContainerRef;
    protected closed: EventEmitter<boolean>;
    config: any;
    /**
     *
     */
    constructor(componentFactoryResolver: ComponentFactoryResolver);
    /**
     * Initializes the Modal if it's in Component Mode
     */
    ngOnInit(): void;
    /**
     * Builds an Instance of the given Component (see global Component Config)
     * Process is delayed because of some problems while loading to early
     */
    protected buildComponentInstance(): void;
    /**
     * Returns an object literal to control the modal from outside (the component context)
     */
    protected getModalCtrl(): {
        close: (result: any) => void;
        config: any;
        component: any;
    };
    /**
     * Returns the Header TemplateRef if it was specified in Modal config
     */
    getHeaderTemplate(): any;
    /**
     * Returns the Body TemplateRef if it was specified in Modal config
     */
    getBodyTemplate(): any;
    /**
     * Returns the Footer TemplateRef if it was specified in Modal config
     */
    getFooterTemplate(): any;
    /**
     * Modal get's closed...
     * Return the ClosingResult (OK=true; Cancel=false;)
     * If the Modal was holding a Component, also return the Component.onModalClose result
     *
     * @param result
     */
    onClick(result: boolean | any): void;
    /**
     *
     * @param result
     */
    closeModal(result: boolean | any): void;
    /**
     *
     */
    emitResult(result: any): void;
    /**
     * Returns inline styles formatted as object (to bind to ngStyle)
     */
    getStyles(): any;
}
