import { BehaviorSubject } from "rxjs/BehaviorSubject";
import { EventEmitter } from "@angular/core";
import 'rxjs/add/operator/toPromise';
export declare class ModalUtils {
    private static defaultConfig;
    static configuration: BehaviorSubject<any>;
    static modalResult: EventEmitter<{}>;
    private static resetConf;
    /**
     * Opening a Modal for displaying a dynamically rendered Component
     * The Component must be passed by config key "component" and has to implement the Modalable Interface
     * The Result is an object containing the closingResult (Ok=true; Cancel=false;) and the componentResult which contains
     * ... the return value of the Components.onModalClose() Method
     * @returns {ModalUtils}
     */
    static component(config?: any, component?: any): Promise<{}>;
    /**
     * Opening a Modal for displaying an Alert
     * @returns {ModalUtils}
     */
    static alert(config?: any): Promise<{}>;
    /**
     * Opening a Modal for displaying an Prompt
     * The prompted result ist available inside the resolving Promise Parameter "result" as string
     * ... if Modal is closed with cancel, result is boolean false
     * @returns {ModalUtils}
     */
    static prompt(config?: any): Promise<{}>;
    /**
     * Opening a Modal for displaying an Confirmation
     * The closing result ist available inside the resolving Promise Parameter "result" as boolean
     * @returns {ModalUtils}
     */
    static confirm(config?: any): Promise<{}>;
    /**
     *
     * @param config
     */
    protected static getInstanceId(config: any): {
        instanceId: string;
    };
}
